# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents an account entity.
    #
    class AccountEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "Account"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The Azure Active Directory tenant id.
      attr_accessor :aad_tenant_id

      # @return [String] The Azure Active Directory user id.
      attr_accessor :aad_user_id

      # @return [String] The name of the account. This field should hold only
      # the name without any domain added to it, i.e. administrator.
      attr_accessor :account_name

      # @return [String] The display name of the account.
      attr_accessor :display_name

      # @return [String] The Host entity id that contains the account in case
      # it is a local account (not domain joined)
      attr_accessor :host_entity_id

      # @return [Boolean] Determines whether this is a domain account.
      attr_accessor :is_domain_joined

      # @return [String] The NetBIOS domain name as it appears in the alert
      # format – domain\username. Examples: NT AUTHORITY.
      attr_accessor :nt_domain

      # @return The objectGUID attribute is a single-value attribute that is
      # the unique identifier for the object, assigned by active directory.
      attr_accessor :object_guid

      # @return [String] The Azure Active Directory Passport User ID.
      attr_accessor :puid

      # @return [String] The account security identifier, e.g. S-1-5-18.
      attr_accessor :sid

      # @return [String] The user principal name suffix for the account, in
      # some cases it is also the domain name. Examples: contoso.com.
      attr_accessor :upn_suffix

      # @return [String] The fully qualified domain DNS name.
      attr_accessor :dns_domain


      #
      # Mapper for AccountEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Account',
          type: {
            name: 'Composite',
            class_name: 'AccountEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              aad_tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.aadTenantId',
                type: {
                  name: 'String'
                }
              },
              aad_user_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.aadUserId',
                type: {
                  name: 'String'
                }
              },
              account_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.accountName',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              host_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostEntityId',
                type: {
                  name: 'String'
                }
              },
              is_domain_joined: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isDomainJoined',
                type: {
                  name: 'Boolean'
                }
              },
              nt_domain: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.ntDomain',
                type: {
                  name: 'String'
                }
              },
              object_guid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.objectGuid',
                type: {
                  name: 'String'
                }
              },
              puid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.puid',
                type: {
                  name: 'String'
                }
              },
              sid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sid',
                type: {
                  name: 'String'
                }
              },
              upn_suffix: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.upnSuffix',
                type: {
                  name: 'String'
                }
              },
              dns_domain: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dnsDomain',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
