# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a dns entity.
    #
    class DnsEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "DnsResolution"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] An ip entity id for the dns server resolving the
      # request
      attr_accessor :dns_server_ip_entity_id

      # @return [String] The name of the dns record associated with the alert
      attr_accessor :domain_name

      # @return [String] An ip entity id for the dns request client
      attr_accessor :host_ip_address_entity_id

      # @return [Array<String>] Ip entity identifiers for the resolved ip
      # address.
      attr_accessor :ip_address_entity_ids


      #
      # Mapper for DnsEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DnsResolution',
          type: {
            name: 'Composite',
            class_name: 'DnsEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              dns_server_ip_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dnsServerIpEntityId',
                type: {
                  name: 'String'
                }
              },
              domain_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.domainName',
                type: {
                  name: 'String'
                }
              },
              host_ip_address_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostIpAddressEntityId',
                type: {
                  name: 'String'
                }
              },
              ip_address_entity_ids: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.ipAddressEntityIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
