# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a file entity.
    #
    class FileEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "File"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The full path to the file.
      attr_accessor :directory

      # @return [Array<String>] The file hash entity identifiers associated
      # with this file
      attr_accessor :file_hash_entity_ids

      # @return [String] The file name without path (some alerts might not
      # include path).
      attr_accessor :file_name

      # @return [String] The Host entity id which the file belongs to
      attr_accessor :host_entity_id


      #
      # Mapper for FileEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'File',
          type: {
            name: 'Composite',
            class_name: 'FileEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              directory: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.directory',
                type: {
                  name: 'String'
                }
              },
              file_hash_entity_ids: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.fileHashEntityIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              file_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.fileName',
                type: {
                  name: 'String'
                }
              },
              host_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostEntityId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
