# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a process entity.
    #
    class ProcessEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "Process"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The account entity id running the processes.
      attr_accessor :account_entity_id

      # @return [String] The command line used to create the process
      attr_accessor :command_line

      # @return [DateTime] The time when the process started to run
      attr_accessor :creation_time_utc

      # @return [ElevationToken] The elevation token associated with the
      # process. Possible values include: 'Default', 'Full', 'Limited'
      attr_accessor :elevation_token

      # @return [String] The host entity id on which the process was running
      attr_accessor :host_entity_id

      # @return [String] The session entity id in which the process was running
      attr_accessor :host_logon_session_entity_id

      # @return [String] Image file entity id
      attr_accessor :image_file_entity_id

      # @return [String] The parent process entity id.
      attr_accessor :parent_process_entity_id

      # @return [String] The process ID
      attr_accessor :process_id


      #
      # Mapper for ProcessEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Process',
          type: {
            name: 'Composite',
            class_name: 'ProcessEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              account_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.accountEntityId',
                type: {
                  name: 'String'
                }
              },
              command_line: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.commandLine',
                type: {
                  name: 'String'
                }
              },
              creation_time_utc: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.creationTimeUtc',
                type: {
                  name: 'DateTime'
                }
              },
              elevation_token: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.elevationToken',
                type: {
                  name: 'Enum',
                  module: 'ElevationToken'
                }
              },
              host_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostEntityId',
                type: {
                  name: 'String'
                }
              },
              host_logon_session_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostLogonSessionEntityId',
                type: {
                  name: 'String'
                }
              },
              image_file_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.imageFileEntityId',
                type: {
                  name: 'String'
                }
              },
              parent_process_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.parentProcessEntityId',
                type: {
                  name: 'String'
                }
              },
              process_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.processId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
