# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a registry key entity.
    #
    class RegistryKeyEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "RegistryKey"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [RegistryHive] the hive that holds the registry key. Possible
      # values include: 'HKEY_LOCAL_MACHINE', 'HKEY_CLASSES_ROOT',
      # 'HKEY_CURRENT_CONFIG', 'HKEY_USERS',
      # 'HKEY_CURRENT_USER_LOCAL_SETTINGS', 'HKEY_PERFORMANCE_DATA',
      # 'HKEY_PERFORMANCE_NLSTEXT', 'HKEY_PERFORMANCE_TEXT', 'HKEY_A',
      # 'HKEY_CURRENT_USER'
      attr_accessor :hive

      # @return [String] The registry key path.
      attr_accessor :key


      #
      # Mapper for RegistryKeyEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RegistryKey',
          type: {
            name: 'Composite',
            class_name: 'RegistryKeyEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              hive: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hive',
                type: {
                  name: 'String'
                }
              },
              key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.key',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
