# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a registry value entity.
    #
    class RegistryValueEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "RegistryValue"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The registry key entity id.
      attr_accessor :key_entity_id

      # @return [String] String formatted representation of the value data.
      attr_accessor :value_data

      # @return [String] The registry value name.
      attr_accessor :value_name

      # @return [RegistryValueKind] Specifies the data types to use when
      # storing values in the registry, or identifies the data type of a value
      # in the registry. Possible values include: 'None', 'Unknown', 'String',
      # 'ExpandString', 'Binary', 'DWord', 'MultiString', 'QWord'
      attr_accessor :value_type


      #
      # Mapper for RegistryValueEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RegistryValue',
          type: {
            name: 'Composite',
            class_name: 'RegistryValueEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              key_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.keyEntityId',
                type: {
                  name: 'String'
                }
              },
              value_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.valueData',
                type: {
                  name: 'String'
                }
              },
              value_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.valueName',
                type: {
                  name: 'String'
                }
              },
              value_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.valueType',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
