# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents scheduled alert rule.
    #
    class ScheduledAlertRule < AlertRule

      include MsRestAzure


      def initialize
        @kind = "Scheduled"
      end

      attr_accessor :kind

      # @return [String] The query that creates alerts for this rule.
      attr_accessor :query

      # @return [Duration] The frequency (in ISO 8601 duration format) for this
      # alert rule to run.
      attr_accessor :query_frequency

      # @return [Duration] The period (in ISO 8601 duration format) that this
      # alert rule looks at.
      attr_accessor :query_period

      # @return [AlertSeverity] The severity for alerts created by this alert
      # rule. Possible values include: 'High', 'Medium', 'Low', 'Informational'
      attr_accessor :severity

      # @return [TriggerOperator] The operation against the threshold that
      # triggers alert rule. Possible values include: 'GreaterThan',
      # 'LessThan', 'Equal', 'NotEqual'
      attr_accessor :trigger_operator

      # @return [Integer] The threshold triggers this alert rule.
      attr_accessor :trigger_threshold

      # @return [EventGroupingSettings] The event grouping settings.
      attr_accessor :event_grouping_settings

      # @return [String] The Name of the alert rule template used to create
      # this rule.
      attr_accessor :alert_rule_template_name

      # @return [String] The description of the alert rule.
      attr_accessor :description

      # @return [String] The display name for alerts created by this alert
      # rule.
      attr_accessor :display_name

      # @return [Boolean] Determines whether this alert rule is enabled or
      # disabled.
      attr_accessor :enabled

      # @return [DateTime] The last time that this alert rule has been
      # modified.
      attr_accessor :last_modified_utc

      # @return [Duration] The suppression (in ISO 8601 duration format) to
      # wait since last time this alert rule been triggered.
      attr_accessor :suppression_duration

      # @return [Boolean] Determines whether the suppression for this alert
      # rule is enabled or disabled.
      attr_accessor :suppression_enabled

      # @return [Array<AttackTactic>] The tactics of the alert rule
      attr_accessor :tactics

      # @return [IncidentConfiguration] The settings of the incidents that
      # created from alerts triggered by this analytics rule
      attr_accessor :incident_configuration


      #
      # Mapper for ScheduledAlertRule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Scheduled',
          type: {
            name: 'Composite',
            class_name: 'ScheduledAlertRule',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              query: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.query',
                type: {
                  name: 'String'
                }
              },
              query_frequency: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.queryFrequency',
                type: {
                  name: 'TimeSpan'
                }
              },
              query_period: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.queryPeriod',
                type: {
                  name: 'TimeSpan'
                }
              },
              severity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.severity',
                type: {
                  name: 'String'
                }
              },
              trigger_operator: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.triggerOperator',
                type: {
                  name: 'Enum',
                  module: 'TriggerOperator'
                }
              },
              trigger_threshold: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.triggerThreshold',
                type: {
                  name: 'Number'
                }
              },
              event_grouping_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.eventGroupingSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EventGroupingSettings'
                }
              },
              alert_rule_template_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.alertRuleTemplateName',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              enabled: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.enabled',
                type: {
                  name: 'Boolean'
                }
              },
              last_modified_utc: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastModifiedUtc',
                type: {
                  name: 'DateTime'
                }
              },
              suppression_duration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.suppressionDuration',
                type: {
                  name: 'TimeSpan'
                }
              },
              suppression_enabled: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.suppressionEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              tactics: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tactics',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AttackTacticElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              incident_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.incidentConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'IncidentConfiguration'
                }
              }
            }
          }
        }
      end
    end
  end
end
