# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Describes threat intelligence ARM STIX query
    #
    class ThreatIntelligenceArmStixQuery

      include MsRestAzure

      # @return [Integer] Page size
      attr_accessor :page_size

      # @return [Integer] Minimum confidence
      attr_accessor :min_confidence

      # @return [Integer] Maximum confidence
      attr_accessor :max_confidence

      # @return [String] Minimum Valid until
      attr_accessor :min_valid_until

      # @return [String] Maximum Valid until
      attr_accessor :max_valid_until

      # @return [Boolean] To include disabled indicators
      attr_accessor :include_disabled

      # @return [Array<ThreatIntelligenceArmStixSortBy1>] List of Sort rules
      attr_accessor :sort_by

      # @return [Array<String>] Sources of a threat intelligence entity
      attr_accessor :sources

      # @return [Array<String>] Pattern types
      attr_accessor :pattern_types

      # @return [Array<String>] Threat types
      attr_accessor :threat_types

      # @return [Array<String>] Ids of threat intelligence entities
      attr_accessor :ids

      # @return [Array<String>] Keywords of threat intelligence entities
      attr_accessor :keywords

      # @return [String] Skip Token
      attr_accessor :skip_token


      #
      # Mapper for ThreatIntelligenceArmStixQuery class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ThreatIntelligenceArmStixQuery',
          type: {
            name: 'Composite',
            class_name: 'ThreatIntelligenceArmStixQuery',
            model_properties: {
              page_size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pageSize',
                type: {
                  name: 'Number'
                }
              },
              min_confidence: {
                client_side_validation: true,
                required: false,
                serialized_name: 'minConfidence',
                type: {
                  name: 'Number'
                }
              },
              max_confidence: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxConfidence',
                type: {
                  name: 'Number'
                }
              },
              min_valid_until: {
                client_side_validation: true,
                required: false,
                serialized_name: 'minValidUntil',
                type: {
                  name: 'String'
                }
              },
              max_valid_until: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxValidUntil',
                type: {
                  name: 'String'
                }
              },
              include_disabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'includeDisabled',
                type: {
                  name: 'Boolean'
                }
              },
              sort_by: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sortBy',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThreatIntelligenceArmStixSortBy1ElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ThreatIntelligenceArmStixSortBy1'
                      }
                  }
                }
              },
              sources: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              pattern_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'patternTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              threat_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'threatTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              ids: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ids',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              keywords: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keywords',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              skip_token: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skipToken',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
