# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2020_01_01
  module Models
    #
    # Represents Amazon Web Services CloudTrail data connector.
    #
    class AwsCloudTrailDataConnector < DataConnector

      include MsRestAzure


      def initialize
        @kind = "AmazonWebServicesCloudTrail"
      end

      attr_accessor :kind

      # @return [String] The Aws Role Arn (with CloudTrailReadOnly policy) that
      # is used to access the Aws account.
      attr_accessor :aws_role_arn

      # @return [AwsCloudTrailDataConnectorDataTypes] The available data types
      # for the connector.
      attr_accessor :data_types


      #
      # Mapper for AwsCloudTrailDataConnector class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AmazonWebServicesCloudTrail',
          type: {
            name: 'Composite',
            class_name: 'AwsCloudTrailDataConnector',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              aws_role_arn: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.awsRoleArn',
                type: {
                  name: 'String'
                }
              },
              data_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataTypes',
                type: {
                  name: 'Composite',
                  class_name: 'AwsCloudTrailDataConnectorDataTypes'
                }
              }
            }
          }
        }
      end
    end
  end
end
